Index: /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/DIA/diawri.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/DIA/diawri.F90	(revision 11913)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/DIA/diawri.F90	(revision 11914)
@@ -934,9 +934,4 @@
       !
       CALL iom_close( inum )
-
-      IF (cdfile_name == "output.abort") THEN
-         CALL ctl_stop('STOP', 'NEMO abort from dia_wri_state')
-      END IF
-       
       ! 
    END SUBROUTINE dia_wri_state
Index: /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/SBC/cpl_oasis3.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/SBC/cpl_oasis3.F90	(revision 11913)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/SBC/cpl_oasis3.F90	(revision 11914)
@@ -42,15 +42,5 @@
    PUBLIC   cpl_freq
    PUBLIC   cpl_finalize
-#if defined key_mpp_mpi
-   INCLUDE 'mpif.h'
-#endif
    
-   INTEGER, PARAMETER         :: localRoot  = 0
-   LOGICAL                    :: commRank            ! true for ranks doing OASIS communication
-#if defined key_cpl_rootexchg
-   LOGICAL                    :: rootexchg =.true.   ! logical switch 
-#else
-   LOGICAL                    :: rootexchg =.false.  ! logical switch 
-#endif 
 
    INTEGER, PUBLIC            ::   OASIS_Rcv  = 1    !: return code if received field
@@ -97,5 +87,4 @@
 
    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   exfld   ! Temporary buffer for receiving
-   INTEGER, PUBLIC :: localComm 
       
    !!----------------------------------------------------------------------
@@ -136,5 +125,4 @@
       IF ( nerror /= OASIS_Ok ) &
          CALL oasis_abort (ncomp_id, 'cpl_init','Failure in oasis_get_localcomm' )
-      localComm = kl_comm 
       !
    END SUBROUTINE cpl_init
@@ -525,7 +513,7 @@
          CALL oasis_get_freqs(id, mop, 1, itmp, info)
 #else
-!         CALL oasis_get_freqs(id,      1, itmp, info)
-         cpl_freq = namflddti( id )
+         CALL oasis_get_freqs(id,      1, itmp, info)
 #endif
+         cpl_freq = itmp(1) 
       ENDIF
       !
Index: /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/SBC/sbccpl.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/SBC/sbccpl.F90	(revision 11913)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/SBC/sbccpl.F90	(revision 11914)
@@ -219,8 +219,5 @@
       ALLOCATE( a_i(jpi,jpj,1) , STAT=ierr(2) )  ! used in sbcice_if.F90 (done here as there is no sbc_ice_if_init)
 #endif
-      !ALLOCATE( xcplmask(jpi,jpj,0:nn_cplmodel) , STAT=ierr(3) )
-      ! Hardwire only two models as nn_cplmodel has not been read in
-      ! from the namelist yet.
-      ALLOCATE( xcplmask(jpi,jpj,0:2) , STAT=ierr(3) )   
+      ALLOCATE( xcplmask(jpi,jpj,0:nn_cplmodel) , STAT=ierr(3) )
       !
       IF( .NOT. ln_apr_dyn ) ALLOCATE( ssh_ib(jpi,jpj), ssh_ibb(jpi,jpj), apr(jpi, jpj), STAT=ierr(4) ) 
@@ -336,5 +333,5 @@
 
       !                                   ! allocate sbccpl arrays
-      !IF( sbc_cpl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_cpl_alloc : unable to allocate arrays' )
+      IF( sbc_cpl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_cpl_alloc : unable to allocate arrays' )
      
       ! ================================ !
Index: /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/SBC/sbcmod.F90
===================================================================
--- /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/SBC/sbcmod.F90	(revision 11913)
+++ /NEMO/branches/UKMO/NEMO_4.0.1_GC_couple_pkg/src/OCE/SBC/sbcmod.F90	(revision 11914)
@@ -291,9 +291,6 @@
       !                             !* OASIS initialization
       !
-      IF( lk_oasis ) THEN
-         IF( sbc_cpl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'sbc_cpl_alloc : unable to allocate arrays' ) 
-         CALL sbc_cpl_init( nn_ice )   ! Must be done before: (1) first time step
-                                       !                      (2) the use of nn_fsbc
-      ENDIF
+      IF( lk_oasis )   CALL sbc_cpl_init( nn_ice )   ! Must be done before: (1) first time step
+      !                                              !                      (2) the use of nn_fsbc
       !     nn_fsbc initialization if OPA-SAS coupling via OASIS
       !     SAS time-step has to be declared in OASIS (mandatory) -> nn_fsbc has to be modified accordingly