Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/cfgs/ORCA2_ICE_ABL/EXPREF/axis_def_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/cfgs/ORCA2_ICE_ABL/EXPREF/axis_def_nemo.xml	(revision 12164)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/cfgs/ORCA2_ICE_ABL/EXPREF/axis_def_nemo.xml	(revision 12164)
@@ -0,0 +1,1 @@
+link ../../SHARED/axis_def_nemo.xml
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/cfgs/ORCA2_ICE_ABL/EXPREF/context_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/cfgs/ORCA2_ICE_ABL/EXPREF/context_nemo.xml	(revision 12163)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/cfgs/ORCA2_ICE_ABL/EXPREF/context_nemo.xml	(revision 12164)
@@ -5,37 +5,36 @@
 -->
 <context id="nemo">
-<!-- $id$ -->
+    <!-- $id$ -->
+    <variable_definition>
+       <!-- Year/Month/Day of time origin for NetCDF files; defaults to 1800-01-01 -->
+       <variable id="ref_year"  type="int"> 1900 </variable>
+       <variable id="ref_month" type="int"> 01 </variable>
+       <variable id="ref_day"   type="int"> 01 </variable>
+       <variable id="rau0"      type="float" > 1026.0 </variable>
+       <variable id="cpocean"   type="float" > 3991.86795711963 </variable>
+       <variable id="convSpsu"  type="float" > 0.99530670233846  </variable>
+       <variable id="rhoic"     type="float" > 917.0 </variable>
+       <variable id="rhosn"     type="float" > 330.0 </variable>
+       <variable id="missval"   type="float" > 1.e20 </variable>
+    </variable_definition>
+
 <!-- Fields definition -->
-    <field_definition src="./field_def_nemo-oce.xml"/>    <!--  NEMO ocean dynamics     --> 
-    <field_definition src="./field_def_nemo-ice.xml"/>    <!--  NEMO sea-ice model      --> 
+    <field_definition src="./field_def_nemo-oce.xml"/>    <!--  NEMO ocean dynamics     -->
+    <field_definition src="./field_def_nemo-ice.xml"/>    <!--  NEMO sea-ice model      -->
 
 <!-- Files definition -->
-    <file_definition src="./file_def_nemo-oce.xml"/>     <!--  NEMO ocean dynamics      --> 
-    <file_definition src="./file_def_nemo-ice.xml"/>     <!--  NEMO sea-ice model       --> 
-    <!-- 
-============================================================================================================
-= grid definition = = DO NOT CHANGE =
-============================================================================================================
-    -->
-    
-    <axis_definition>
-      <axis id="deptht" long_name="Vertical T levels" unit="m" positive="down" />
-      <axis id="depthu" long_name="Vertical U levels" unit="m" positive="down" />
-      <axis id="depthv" long_name="Vertical V levels" unit="m" positive="down" />
-      <axis id="depthw" long_name="Vertical W levels" unit="m" positive="down" />
-      <axis id="profsed" long_name="Vertical S levels" unit="cm" positive="down" />
-      <axis id="nfloat" long_name="Float number"      unit="-"                 />
-      <axis id="icbcla"  long_name="Iceberg class"      unit="1"               />
-      <axis id="ncatice" long_name="Ice category"       unit="1"               />
-      <axis id="iax_20C" long_name="20 degC isotherm"   unit="degC"            />
-      <axis id="iax_28C" long_name="28 degC isotherm"   unit="degC"            />
-      <!-- ABL vertical axis definition -->
-      <axis id="ght_abl" long_name="ABL Vertical T levels" unit="m" positive="up"   />
-      <axis id="ghw_abl" long_name="ABL Vertical W levels" unit="m" positive="up"   />
-    </axis_definition>
+    <file_definition src="./file_def_nemo-oce.xml"/>     <!--  NEMO ocean dynamics      -->
+    <file_definition src="./file_def_nemo-ice.xml"/>     <!--  NEMO sea-ice model       -->
+
+
+<!-- Axis definition -->
+    <axis_definition src="./axis_def_nemo.xml"/>
  
+<!-- Domain definition -->
     <domain_definition src="./domain_def_nemo.xml"/>
+
+<!-- Grids definition -->
+    <grid_definition   src="./grid_def_nemo.xml"/>
   
-    <grid_definition src="./grid_def_nemo.xml"/>
-    
+
 </context>
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/cfgs/SHARED/axis_def_nemo.xml
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/cfgs/SHARED/axis_def_nemo.xml	(revision 12163)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/cfgs/SHARED/axis_def_nemo.xml	(revision 12164)
@@ -22,4 +22,7 @@
       <axis id="basin"   long_name="Sub-basin mask (1=Global 2=Atlantic 3=Indo-Pacific 4=Indian, 5=Pacific)"  unit="1" />
       <axis id="nstrait" long_name="Number of straits" unit="1" />
+      <!-- ABL vertical axis definition -->
+      <axis id="ght_abl" long_name="ABL Vertical T levels" unit="m" positive="up"   />
+      <axis id="ghw_abl" long_name="ABL Vertical W levels" unit="m" positive="up"   />
       <axis id="section"     n_glo="16" />
       <axis id="section_ice" n_glo="4" />