Index: utils/CI/sette_top_pisces_lbc/sette_test-cases.sh
===================================================================
--- utils/CI/sette_top_pisces_lbc/sette_test-cases.sh	(revision 11795)
+++ utils/CI/sette_top_pisces_lbc/sette_test-cases.sh	(revision 12211)
@@ -179,5 +179,4 @@
     set_namelist namelist_cfg nn_itend 120
     set_namelist namelist_cfg nn_stock 60
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -200,5 +199,4 @@
     set_namelist namelist_cfg nn_itend 120
     set_namelist namelist_cfg nn_stock 60
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -275,5 +273,4 @@
     set_namelist namelist_cfg nn_it000 1
     set_namelist namelist_cfg nn_stock 60
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -297,5 +294,4 @@
     set_namelist namelist_cfg nn_itend 120
     set_namelist namelist_cfg nn_stock 60
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -374,5 +370,4 @@
     set_namelist namelist_cfg nn_itend 240
     set_namelist namelist_cfg nn_stock 120
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -382,5 +377,4 @@
     set_namelist 1_namelist_cfg nn_itend 720
     set_namelist 1_namelist_cfg nn_stock 360
-    set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
@@ -404,5 +398,4 @@
     set_namelist namelist_cfg nn_itend 240
     set_namelist namelist_cfg nn_stock 120
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -414,5 +407,4 @@
     set_namelist 1_namelist_cfg nn_it000 361
     set_namelist 1_namelist_cfg nn_itend 720
-    set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
@@ -462,5 +454,4 @@
     set_namelist namelist_cfg jpni 2
     set_namelist namelist_cfg jpnj 3
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -472,5 +463,4 @@
     set_namelist 1_namelist_cfg jpni 2
     set_namelist 1_namelist_cfg jpnj 3
-    set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
@@ -502,5 +492,4 @@
     set_namelist namelist_cfg jpni 3
     set_namelist namelist_cfg jpnj 2
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -512,5 +501,4 @@
     set_namelist 1_namelist_cfg jpni 3
     set_namelist 1_namelist_cfg jpnj 2
-    set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
@@ -550,5 +538,4 @@
     set_namelist namelist_cfg nn_it000 1
     set_namelist namelist_cfg nn_itend 200
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -558,5 +545,4 @@
     set_namelist 1_namelist_cfg nn_it000 1
     set_namelist 1_namelist_cfg nn_itend 600
-    set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
@@ -580,5 +566,4 @@
     set_namelist namelist_cfg nn_it000 101
     set_namelist namelist_cfg nn_itend 200
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -592,5 +577,4 @@
     set_namelist 1_namelist_cfg nn_it000 301
     set_namelist 1_namelist_cfg nn_itend 600
-    set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
@@ -648,5 +632,4 @@
     set_namelist namelist_cfg jpni 2
     set_namelist namelist_cfg jpnj 3
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -658,5 +641,4 @@
     set_namelist 1_namelist_cfg jpni 2
     set_namelist 1_namelist_cfg jpnj 3
-    set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
@@ -688,5 +670,4 @@
     set_namelist namelist_cfg jpni 3
     set_namelist namelist_cfg jpnj 2
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -698,5 +679,4 @@
     set_namelist 1_namelist_cfg jpni 3
     set_namelist 1_namelist_cfg jpnj 2
-    set_namelist 1_namelist_cfg ln_ctl .false.
     set_namelist 1_namelist_cfg sn_cfctl%l_config .true.
     set_namelist 1_namelist_cfg sn_cfctl%l_runstat .true.
@@ -738,5 +718,4 @@
     set_namelist namelist_cfg jpni 5
     set_namelist namelist_cfg jpnj 3
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -763,5 +742,4 @@
     set_namelist namelist_cfg jpni 5
     set_namelist namelist_cfg jpnj 3
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -801,5 +779,4 @@
     set_namelist namelist_cfg jpni 7
     set_namelist namelist_cfg jpnj 3
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.
@@ -828,5 +805,4 @@
     set_namelist namelist_cfg jpni 8
     set_namelist namelist_cfg jpnj 4
-    set_namelist namelist_cfg ln_ctl .false.
     set_namelist namelist_cfg sn_cfctl%l_config .true.
     set_namelist namelist_cfg sn_cfctl%l_runstat .true.